/*
 * DeleteXbyteFiles
 *
 *
 */

#define CONSOLE


#include <stdio.h>
#include <dir.h>
#include <dirent.h>
#include <sys/stat.h>

#ifndef CONSOLE
#define STRICT
#include <windows.h>
#endif

#define MSG_ERROR_CURRENT_DIRECTORY			"JgfBNg̕ύXɎs܂"


int delete_current_directory_files(long int del_size);


#ifdef CONSOLE
int main(int argc, char **argv)
#else
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPevInstance, LPSTR lpCmdLine, int nCmdShow)
#endif
{
	long int delete_file_size = 0U;
	int count;

#ifdef CONSOLE
	if (argc > 1) {
		int i;

		for (i = 1; i < argc; i++) {
			if (argv[i][0] == '#')
				delete_file_size = (unsigned long int) atol(&argv[i][1]);
			else
				if (chdir(argv[i])) {
					fputs(MSG_ERROR_CURRENT_DIRECTORY "\n", stderr);
					return 1;
				}
		}
	}

#else
	if (lpCmdLine[0] != '\0') {
		LPSTR DirName;

		if (lpCmdLine[0] != '"')
			DirName = lpCmdLine;
		else {
			INT len;

			len = lstrlen(lpCmdLine);

			while (--len)
				if (lpCmdLine[len] == '"') {
					lpCmdLine[len] = '\0';
					break;
				}

			DirName = &lpCmdLine[1];
		}

		if (!SetCurrentDirectory(DirName)) {
			MessageBox(NULL, TEXT(MSG_ERROR_CURRENT_DIRECTORY), DirName, MB_OK | MB_ICONWARNING);
			return 1;
		}
	}
#endif

	count = delete_current_directory_files(delete_file_size);

	if (count > 0)
		printf("%u ̃t@C폜܂B\n", (unsigned int) count);

	return 0;
}


int delete_current_directory_files(long int del_size)
{
	int del_count = 0;
	DIR *dir;
	struct dirent *dp;
	struct stat st; 

	dir = opendir(".");

	if (!dir)
		return -1;

	while (dp = readdir(dir))
		if (!stat(dp -> d_name, &st))
			if (!(st.st_mode & S_IFDIR))
				if (st.st_size == del_size)
					if (!remove(dp -> d_name))
						puts(dp -> d_name), del_count++;

	closedir(dir);

	return del_count;
}

